# System Monitoring Center

GTK3 and Python 3 based, system performance and usage monitoring tool.

<a href="https://sourceforge.net/projects/system-monitoring-center/files/latest/download"><img alt="Download System Monitoring Center" src="https://a.fsdn.com/con/app/sf-download-button" width=276 height=48 srcset="https://a.fsdn.com/con/app/sf-download-button?button_size=2x 2x"></a>
</a>
<a href="https://sourceforge.net/projects/system-monitoring-center/files/latest/download"><img alt="Download System Monitoring Center" src="https://img.shields.io/sourceforge/dt/system-monitoring-center.svg" ></a>
</a>

<a href="https://repology.org/project/system-monitoring-center/versions">
    <img src="https://repology.org/badge/vertical-allrepos/system-monitoring-center.svg" alt="Packaging status">
</a>

### Features:
* Detailed system performance monitoring features
    * Monitoring CPU, RAM, Disk, Network, GPU, Sensor hardware information/performance/usage
    * An always on top and semi-transparent floating summary window for performance monitoring
    * Monitoring and managing processes
    * Monitoring users and per-user performance data
    * Monitoring and managing storage (non-removable, removable, optical/virtual disks, etc.)
    * Monitoring and managing startup applications (currently supports XFCE, GNOME, CINNAMON, MATE, KDE Plasma, GNOME-CLASSIC, LXQt, LXDE desktop environments)
    * Monitoring and managing system services (systemd services)
    * Monitoring and managing persistent environment variables and shell variables
    * Monitoring general system information
* Customization options per-tab
* Low system resource usage while monitoring
* Language support (more languages will be added if translations are provided by contributors):
    * English, Turkish
* Provides help and additional information when mouse hover action is performed on several GUI objects
* Adapts to system theme
* Free and open sourced



![System Monitoring Center](screenshots/cpu_tab_dark_system_theme_tr.png)

![System Monitoring Center](screenshots/cpu_tab_customizations.png)

![System Monitoring Center](screenshots/cpu_tab_default_system_theme.png)

![System Monitoring Center](screenshots/cpu_tab_per_core_dark.png)

![System Monitoring Center](screenshots/network_tab_dark_system_theme.png)

![System Monitoring Center](screenshots/gpu_tab_dark_system_theme.png)

![System Monitoring Center](screenshots/sensors_tab_dark_system_theme.png)

![System Monitoring Center](screenshots/processes_list_view_dark.png)

![System Monitoring Center](screenshots/processes_tab_tree_view_dark.png)

![System Monitoring Center](screenshots/storage_tab_dark_system_theme.png)

![System Monitoring Center](screenshots/storage_tab_disk_details_dark.png)

![System Monitoring Center](screenshots/startup_tab_dark_system_theme.png)

![System Monitoring Center](screenshots/services_tab_dark_system_theme.png)

![System Monitoring Center](screenshots/environment_variables_tab_dark.png)

![System Monitoring Center](screenshots/system_tab_dark_system_theme.png)

### Dependencies:
* Python 3.7 (Programming language)
* GTK 3.24 (GUI)
* python3-opengl (for FPS counting)

### Status:
<br/>Under development, some features are not coded (very rare) and there may be bugs to be fixed.

Note: Developed on Pardus 21 XFCE (Debian-like GNU/Linux, Kernel: 5.10.0-8-amd64).
